package net.vision_design.loginapp;

import android.annotation.SuppressLint;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v4.app.Fragment;

import android.support.v4.app.FragmentActivity;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentTransaction;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;

import com.roomorama.caldroid.CaldroidFragment;
import com.roomorama.caldroid.CaldroidListener;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;

@SuppressLint("SimpleDateFormat")
public class ThirdFragment extends Fragment {
    String user_id;
    String ini_year, ini_month;
    private boolean undo = false;
    private CaldroidFragment caldroidFragment;
    private CaldroidFragment dialogCaldroidFragment;
    JSONArray jArray = null;

    private void setCustomResourceForDates() {
        Calendar cal = Calendar.getInstance();
        //cal.setTime(date);
        ini_year = String.valueOf(cal.get(Calendar.YEAR));
        ini_month = String.valueOf(cal.get(Calendar.MONTH) + 1);

        String url = "http://xelf.ca/registration/getRecordDate.php";

        GetRecordDate getRecordDate = new GetRecordDate();
        String r = "Hello";
        try {
            r = getRecordDate.execute(url, user_id, ini_year, ini_month).get();
        }catch (Exception e){

        }

        JSONObject jsonObj = null;
        try {
            jsonObj = new JSONObject(r);
            jArray = jsonObj.getJSONArray("result");
            for (int i = 0; i < jArray.length(); i++) {
                JSONObject json_data = jArray.getJSONObject(i);
                String i_year = json_data.getString("ex_year");
                String i_month = json_data.getString("ex_month");
                String i_day = json_data.getString("ex_day");

                String i_date = i_day + "/" + i_month + "/" + i_year;
                SimpleDateFormat form = new SimpleDateFormat("dd/MM/yyyy");
                java.util.Date d1 = null;
                try {
                    d1 = form.parse(i_date);
                }catch (Exception e){}
                Calendar cal1 = Calendar.getInstance();
                cal1.setTime(d1);
                Date d = cal1.getTime();
              //  ColorDrawable green = new ColorDrawable(Color.GREEN);
              //  caldroidFragment.setBackgroundDrawableForDate(green, d);
                ColorDrawable green = new ColorDrawable(Color.parseColor("#00EEFF"));
                caldroidFragment.setBackgroundDrawableForDate(green, d);
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }

    }

    public void setCustomResourceForDates(int year, int month) {

        Calendar cal = Calendar.getInstance();
        //cal.setTime(date);
        ini_year = String.valueOf(year);
        ini_month = String.valueOf(month);

        String url = "http://xelf.ca/registration/getRecordDate.php";

        GetRecordDate getRecordDate = new GetRecordDate();
        String r = "Hello";
        try {
            r = getRecordDate.execute(url, user_id, ini_year, ini_month).get();
        }catch (Exception e){

        }

        JSONObject jsonObj = null;
        try {
            jsonObj = new JSONObject(r);
            jArray = jsonObj.getJSONArray("result");
            for (int i = 0; i < jArray.length(); i++) {
                JSONObject json_data = jArray.getJSONObject(i);
                String i_year = json_data.getString("ex_year");
                String i_month = json_data.getString("ex_month");
                String i_day = json_data.getString("ex_day");

                String i_date = i_day + "/" + i_month + "/" + i_year;
                SimpleDateFormat form = new SimpleDateFormat("dd/MM/yyyy");
                java.util.Date d1 = null;
                try {
                    d1 = form.parse(i_date);
                }catch (Exception e){}
                Calendar cal1 = Calendar.getInstance();
                cal1.setTime(d1);
                Date d = cal1.getTime();
                //ColorDrawable green = new ColorDrawable(Color.GREEN);
                //caldroidFragment.setBackgroundDrawableForDate(green, d);
                ColorDrawable green = new ColorDrawable(Color.parseColor("#00EEFF"));
                caldroidFragment.setBackgroundDrawableForDate(green, d);
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }

    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {

        View rootView = inflater.inflate(R.layout.third_fragment, container, false);

        return rootView;
    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);

        //final GlobalUserid globalUserid = (GlobalUserid) getActivity().getApplicationContext();
        //user_id  = String.valueOf(globalUserid.getUserid());
        user_id = SaveSharedPreference.getUserId(ThirdFragment.super.getContext());

        final SimpleDateFormat formatter = new SimpleDateFormat("dd MMM yyyy");

        // Setup caldroid fragment
        // **** If you want normal CaldroidFragment, use below line ****
        caldroidFragment = new CaldroidFragment();

        // //////////////////////////////////////////////////////////////////////
        // **** This is to show customized fragment. If you want customized
        // version, uncomment below line ****
//		 caldroidFragment = new CaldroidSampleCustomFragment();

        // Setup arguments

        // If Activity is created after rotation
        if (savedInstanceState != null) {
            caldroidFragment.restoreStatesFromKey(savedInstanceState,
                    "CALDROID_SAVED_STATE");
        }
        // If activity is created from fresh
        else {
            Bundle args = new Bundle();
            Calendar cal = Calendar.getInstance();
            args.putInt(CaldroidFragment.MONTH, cal.get(Calendar.MONTH) + 1);
            args.putInt(CaldroidFragment.YEAR, cal.get(Calendar.YEAR));
            args.putBoolean(CaldroidFragment.ENABLE_SWIPE, true);
            args.putBoolean(CaldroidFragment.SIX_WEEKS_IN_CALENDAR, true);


            // Uncomment this to customize startDayOfWeek
            // args.putInt(CaldroidFragment.START_DAY_OF_WEEK,
            // CaldroidFragment.TUESDAY); // Tuesday

            // Uncomment this line to use Caldroid in compact mode
            // args.putBoolean(CaldroidFragment.SQUARE_TEXT_VIEW_CELL, false);

            // Uncomment this line to use dark theme
//            args.putInt(CaldroidFragment.THEME_RESOURCE, com.caldroid.R.style.CaldroidDefaultDark);

            caldroidFragment.setArguments(args);
            Date date1 = cal.getTime();
            cal.add(Calendar.DAY_OF_MONTH, -15);
            Date date2 = cal.getTime();
            caldroidFragment.setMinDate(date2);
            caldroidFragment.setMaxDate(date1);
        }

        setCustomResourceForDates();

        // Attach to the activity
        FragmentTransaction t = getActivity().getSupportFragmentManager().beginTransaction();
        t.replace(R.id.calendar1, caldroidFragment);
        t.commit();

        // Setup listener
        final CaldroidListener listener = new CaldroidListener() {

            @Override
            public void onSelectDate(Date date, View view) {
                Calendar cal = Calendar.getInstance();
                cal.setTime(date);
                int ex_year = cal.get(Calendar.YEAR);
                int ex_month = cal.get(Calendar.MONTH);
                int ex_day = cal.get(Calendar.DAY_OF_MONTH);

                Bundle args = new Bundle();
                args.putInt("ex_year", ex_year);
                args.putInt("ex_month", ex_month);
                args.putInt("ex_day", ex_day);

                FragmentTransaction fragmentTransaction = getActivity()
                        .getSupportFragmentManager()
                        .beginTransaction();
                Fragment excerciseSession = new ExcerciseSession();
                excerciseSession.setArguments(args);
                fragmentTransaction.replace(R.id.calendar1, excerciseSession);
                fragmentTransaction.addToBackStack(null);
                fragmentTransaction.commit();
            }

            @Override  //change month by click left or right arrow
            public void onChangeMonth(int month, int year) {
                setCustomResourceForDates(year, month);
               /* String text = "month: " + month + " year: " + year;
                Toast.makeText(getContext().getApplicationContext(), text,
                        Toast.LENGTH_SHORT).show();*/
            }

            @Override  //click the day cell for extra long time
            public void onLongClickDate(Date date, View view) {
                Toast.makeText(getContext().getApplicationContext(),
                        "Long click " + formatter.format(date),
                        Toast.LENGTH_SHORT).show();
            }

            @Override
            public void onCaldroidViewCreated() {
                if (caldroidFragment.getLeftArrowButton() != null) {
                   /* Toast.makeText(getContext().getApplicationContext(),
                            "Caldroid view is created", Toast.LENGTH_SHORT)
                            .show();*/
                }
            }

        };

        // Setup Caldroid
        caldroidFragment.setCaldroidListener(listener);


    }

    /**
     * Save current states of the Caldroid here
     */
    @Override
    public void onSaveInstanceState(Bundle outState) {
        // TODO Auto-generated method stub
        super.onSaveInstanceState(outState);

        if (caldroidFragment != null) {
            caldroidFragment.saveStatesToKey(outState, "CALDROID_SAVED_STATE");
        }

        if (dialogCaldroidFragment != null) {
            dialogCaldroidFragment.saveStatesToKey(outState,
                    "DIALOG_CALDROID_SAVED_STATE");
        }
    }

    public class GetRecordDate extends AsyncTask<String, Void, String> {

        protected void onPreExecute() {
        }

        @Override
        protected String doInBackground(String... params) {
            try {
                URL url = new URL(params[0]);
                JSONObject postDataParams = new JSONObject();
                postDataParams.put("userid", params[1]);
                postDataParams.put("year", params[2]);
                postDataParams.put("month", params[3]);
                Log.e("params", postDataParams.toString());

                HttpURLConnection conn = (HttpURLConnection) url.openConnection();
                conn.setReadTimeout(3500);
                conn.setConnectTimeout(3500);  /* milliseconds */
                conn.setRequestMethod("POST");
                conn.setDoInput(true);
                conn.setDoOutput(true);

                OutputStream os = conn.getOutputStream();
                BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(os, "UTF-8"));
                writer.write(getPostDataString(postDataParams));

                writer.flush();
                writer.close();
                os.close();

                int responseCode = conn.getResponseCode();

                if (responseCode == HttpURLConnection.HTTP_OK) {

                    BufferedReader in = new BufferedReader(
                            new InputStreamReader(
                                    conn.getInputStream()));
                    StringBuffer sb = new StringBuffer("");
                    String line = "";

                    while ((line = in.readLine()) != null) {

                        sb.append(line);
                        break;
                    }

                    in.close();
                    return sb.toString();

                } else {
                    return new String("false : " + responseCode);
                }
            } catch (Exception e) {
                return new String("Exception: " + e.getMessage());
            }

        }

        @Override
        protected void onPostExecute(String result) {

        }

        public String getPostDataString(JSONObject params) throws Exception {

            StringBuilder result = new StringBuilder();
            boolean first = true;

            Iterator<String> itr = params.keys();

            while (itr.hasNext()) {

                String key = itr.next();
                Object value = params.get(key);

                if (first)
                    first = false;
                else
                    result.append("&");

                result.append(URLEncoder.encode(key, "UTF-8"));
                result.append("=");
                result.append(URLEncoder.encode(value.toString(), "UTF-8"));

            }
            return result.toString();
        }
    }

}

